<template>
    <div :style="SizeStyle">
        <WorkerIndicator
            :compare-time="compareTime"
            @select-worker="$emit('select-worker', $event)"
            :width="fpW"
            :height="fpH"
            v-for="w in workers"
            :key="w.id"
            :pulse="pulse"
            :display-inactive="displayInactive"
            :dot-size="dotSize"
            :inactive-duration="inactiveDuration"
            :label-mode="labelMode"
            :label-shape="labelShape"
            :label-size="labelSize"
            :label-background-color="labelBackgroundColor"
            :label-color="labelColor"
            :border-color="labelBorderColor"
            :border-size="labelBorderSize"
            :label-background-transparency="labelBackgroundOpacity"
            :selected="selected"
            :hovered="hovered"
            :worker="w"/>
    </div>
</template>

<style lang='scss' scoped>
</style>

<script lang='ts'>
import {Component, Prop, Vue} from 'vue-property-decorator';
import {WorkerPositionResponse} from "src/classLibrary/APIModels/core/workerPositionResponse";
import {LabelShape, WorkerColorMode, WorkerLabelMode} from "src/classLibrary/Geometry/ShapeDrawer";
import WorkerIndicator from "components/FloorPlan/WorkerIndicator.vue";

@Component({
    components: {WorkerIndicator}
})
export default class FloorPlanWorkerRenderer extends Vue {
    @Prop() compareTime!: Date;
    @Prop() pulse!: boolean;
    @Prop() workers!: { [s: string]: WorkerPositionResponse }
    @Prop() width!: number;
    @Prop() height!: number;
    @Prop() dotSize!: number;
    @Prop() labelSize!: number;
    @Prop() labelColor!: string;
    @Prop() labelBorderSize!: number;
    @Prop() labelBorderColor!: string;
    @Prop() labelBackgroundColor!: string;
    @Prop() labelBackgroundOpacity!: string;
    @Prop() colorMode!: WorkerColorMode;
    @Prop() labelMode!: WorkerLabelMode;
    @Prop() labelShape!: LabelShape;
    @Prop() displayInactive!: boolean;
    @Prop() inactiveDuration!: number;
    @Prop() fpW!: number;
    @Prop() fpH!: number;
    @Prop() selected!: WorkerPositionResponse | null;
    @Prop() hovered!: WorkerPositionResponse | null;

    // prevSize = 3;
    // modifiedWorkers: { [s: string]: WorkerPositionResponse } = {};
    //
    // @Watch('workers', {deep: true, immediate: true})
    // OnWorkerUpdate() {
    //     this.modifiedWorkers = this.Workers();
    // }
    //
    //
    //
    // @Watch('colorMode')
    // OnColorModeUpdate() {
    //     this.modifiedWorkers = this.Workers();
    // }
    //
    // Workers(): { [s: string]: WorkerPositionResponse } {
    //     if (this.colorMode === 'subcon') {
    //         return this.workers;
    //     } else {
    //         const w = new Map<string, WorkerPositionResponse>(Object.entries(this.workers));
    //         const length = w.size > 2 ? w.size : 3;
    //         let colorSpace: Map<string, string>;
    //         if (this.colorMode === 'distinct') {
    //             const cs = [0, 360, 8, 40, 7, 40] as any;
    //             const options = {
    //                 colorSpace: cs,
    //             } as any;
    //             const colors = iwanthue(length, options);
    //             colorSpace = w.Keys().AsKey((_, i) => colors[i])
    //         } else {
    //             const cs = [0, 360, 40, 70, 15, 85] as any;
    //             const options = {
    //                 colorSpace: cs,
    //             } as any;
    //             const colors = iwanthue(length, options);
    //             colorSpace = w.Keys().AsKey((_, i) => colors[i])
    //         }
    //         return w.MapValue((v, k) => {
    //             v.color = colorSpace.get(k)!;
    //             return v;
    //         }).AsObject() as { [s: string]: WorkerPositionResponse };
    //     }
    //
    //
    // }


    get SizeStyle() {
        const width = this.width + "px";
        const height = this.height + "px";


        return {
            width,
            height,
            position: 'relative',
        }
    }
}
</script>
